/**
 * @name json-variables
 * @fileoverview Resolves custom-marked, cross-referenced paths in parsed JSON
 * @version 12.0.11
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/json-variables/}
 */

"use strict";var jsonVariables=(()=>{var Zr=Object.create;var U=Object.defineProperty,Yr=Object.defineProperties,Xr=Object.getOwnPropertyDescriptor,et=Object.getOwnPropertyDescriptors,rt=Object.getOwnPropertyNames,Je=Object.getOwnPropertySymbols,tt=Object.getPrototypeOf,Fe=Object.prototype.hasOwnProperty,nt=Object.prototype.propertyIsEnumerable;var de=(e,r,t)=>r in e?U(e,r,{enumerable:!0,configurable:!0,writable:!0,value:t}):e[r]=t,v=(e,r)=>{for(var t in r||(r={}))Fe.call(r,t)&&de(e,t,r[t]);if(Je)for(var t of Je(r))nt.call(r,t)&&de(e,t,r[t]);return e},K=(e,r)=>Yr(e,et(r));var ke=(e,r)=>()=>(r||e((r={exports:{}}).exports,r),r.exports),it=(e,r)=>{for(var t in r)U(e,t,{get:r[t],enumerable:!0})},Le=(e,r,t,i)=>{if(r&&typeof r=="object"||typeof r=="function")for(let l of rt(r))!Fe.call(e,l)&&l!==t&&U(e,l,{get:()=>r[l],enumerable:!(i=Xr(r,l))||i.enumerable});return e};var ye=(e,r,t)=>(t=e!=null?Zr(tt(e)):{},Le(r||!e||!e.__esModule?U(t,"default",{value:e,enumerable:!0}):t,e)),at=e=>Le(U({},"__esModule",{value:!0}),e);var me=(e,r,t)=>(de(e,typeof r!="symbol"?r+"":r,t),t);var Re=ke((Z,F)=>{var pt=200,hr="__lodash_hash_undefined__",gr=9007199254740991,Se="[object Arguments]",dt="[object Array]",pr="[object Boolean]",dr="[object Date]",yt="[object Error]",Ie="[object Function]",yr="[object GeneratorFunction]",te="[object Map]",mr="[object Number]",We="[object Object]",rr="[object Promise]",wr="[object RegExp]",ne="[object Set]",br="[object String]",Tr="[object Symbol]",$e="[object WeakMap]",$r="[object ArrayBuffer]",ie="[object DataView]",vr="[object Float32Array]",Or="[object Float64Array]",Ar="[object Int8Array]",_r="[object Int16Array]",Er="[object Int32Array]",Sr="[object Uint8Array]",Ir="[object Uint8ClampedArray]",Wr="[object Uint16Array]",Dr="[object Uint32Array]",mt=/[\\^$.*+?()[\]{}|]/g,wt=/\w*$/,bt=/^\[object .+?Constructor\]$/,Tt=/^(?:0|[1-9]\d*)$/,O={};O[Se]=O[dt]=O[$r]=O[ie]=O[pr]=O[dr]=O[vr]=O[Or]=O[Ar]=O[_r]=O[Er]=O[te]=O[mr]=O[We]=O[wr]=O[ne]=O[br]=O[Tr]=O[Sr]=O[Ir]=O[Wr]=O[Dr]=!0;O[yt]=O[Ie]=O[$e]=!1;var $t=typeof global=="object"&&global&&global.Object===Object&&global,vt=typeof self=="object"&&self&&self.Object===Object&&self,C=$t||vt||Function("return this")(),xr=typeof Z=="object"&&Z&&!Z.nodeType&&Z,tr=xr&&typeof F=="object"&&F&&!F.nodeType&&F,Ot=tr&&tr.exports===xr;function At(e,r){return e.set(r[0],r[1]),e}function _t(e,r){return e.add(r),e}function Et(e,r){for(var t=-1,i=e?e.length:0;++t<i&&r(e[t],t,e)!==!1;);return e}function St(e,r){for(var t=-1,i=r.length,l=e.length;++t<i;)e[l+t]=r[t];return e}function Nr(e,r,t,i){var l=-1,n=e?e.length:0;for(i&&n&&(t=e[++l]);++l<n;)t=r(t,e[l],l,e);return t}function It(e,r){for(var t=-1,i=Array(e);++t<e;)i[t]=r(t);return i}function Wt(e,r){return e==null?void 0:e[r]}function Cr(e){var r=!1;if(e!=null&&typeof e.toString!="function")try{r=!!(e+"")}catch(t){}return r}function nr(e){var r=-1,t=Array(e.size);return e.forEach(function(i,l){t[++r]=[l,i]}),t}function De(e,r){return function(t){return e(r(t))}}function ir(e){var r=-1,t=Array(e.size);return e.forEach(function(i){t[++r]=i}),t}var Dt=Array.prototype,xt=Function.prototype,ae=Object.prototype,Te=C["__core-js_shared__"],ar=function(){var e=/[^.]+$/.exec(Te&&Te.keys&&Te.keys.IE_PROTO||"");return e?"Symbol(src)_1."+e:""}(),Rr=xt.toString,V=ae.hasOwnProperty,se=ae.toString,Nt=RegExp("^"+Rr.call(V).replace(mt,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),sr=Ot?C.Buffer:void 0,or=C.Symbol,lr=C.Uint8Array,Ct=De(Object.getPrototypeOf,Object),Rt=Object.create,Vt=ae.propertyIsEnumerable,jt=Dt.splice,ur=Object.getOwnPropertySymbols,Ht=sr?sr.isBuffer:void 0,Mt=De(Object.keys,Object),ve=q(C,"DataView"),Y=q(C,"Map"),Oe=q(C,"Promise"),Ae=q(C,"Set"),_e=q(C,"WeakMap"),X=q(Object,"create"),Pt=M(ve),Bt=M(Y),Jt=M(Oe),Ft=M(Ae),kt=M(_e),fr=or?or.prototype:void 0,cr=fr?fr.valueOf:void 0;function H(e){var r=-1,t=e?e.length:0;for(this.clear();++r<t;){var i=e[r];this.set(i[0],i[1])}}function Lt(){this.__data__=X?X(null):{}}function qt(e){return this.has(e)&&delete this.__data__[e]}function Ut(e){var r=this.__data__;if(X){var t=r[e];return t===hr?void 0:t}return V.call(r,e)?r[e]:void 0}function Kt(e){var r=this.__data__;return X?r[e]!==void 0:V.call(r,e)}function Gt(e,r){var t=this.__data__;return t[e]=X&&r===void 0?hr:r,this}H.prototype.clear=Lt;H.prototype.delete=qt;H.prototype.get=Ut;H.prototype.has=Kt;H.prototype.set=Gt;function R(e){var r=-1,t=e?e.length:0;for(this.clear();++r<t;){var i=e[r];this.set(i[0],i[1])}}function Qt(){this.__data__=[]}function zt(e){var r=this.__data__,t=oe(r,e);if(t<0)return!1;var i=r.length-1;return t==i?r.pop():jt.call(r,t,1),!0}function Zt(e){var r=this.__data__,t=oe(r,e);return t<0?void 0:r[t][1]}function Yt(e){return oe(this.__data__,e)>-1}function Xt(e,r){var t=this.__data__,i=oe(t,e);return i<0?t.push([e,r]):t[i][1]=r,this}R.prototype.clear=Qt;R.prototype.delete=zt;R.prototype.get=Zt;R.prototype.has=Yt;R.prototype.set=Xt;function k(e){var r=-1,t=e?e.length:0;for(this.clear();++r<t;){var i=e[r];this.set(i[0],i[1])}}function en(){this.__data__={hash:new H,map:new(Y||R),string:new H}}function rn(e){return le(this,e).delete(e)}function tn(e){return le(this,e).get(e)}function nn(e){return le(this,e).has(e)}function an(e,r){return le(this,e).set(e,r),this}k.prototype.clear=en;k.prototype.delete=rn;k.prototype.get=tn;k.prototype.has=nn;k.prototype.set=an;function L(e){this.__data__=new R(e)}function sn(){this.__data__=new R}function on(e){return this.__data__.delete(e)}function ln(e){return this.__data__.get(e)}function un(e){return this.__data__.has(e)}function fn(e,r){var t=this.__data__;if(t instanceof R){var i=t.__data__;if(!Y||i.length<pt-1)return i.push([e,r]),this;t=this.__data__=new k(i)}return t.set(e,r),this}L.prototype.clear=sn;L.prototype.delete=on;L.prototype.get=ln;L.prototype.has=un;L.prototype.set=fn;function cn(e,r){var t=Ne(e)||Vn(e)?It(e.length,String):[],i=t.length,l=!!i;for(var n in e)(r||V.call(e,n))&&!(l&&(n=="length"||xn(n,i)))&&t.push(n);return t}function Vr(e,r,t){var i=e[r];(!(V.call(e,r)&&Pr(i,t))||t===void 0&&!(r in e))&&(e[r]=t)}function oe(e,r){for(var t=e.length;t--;)if(Pr(e[t][0],r))return t;return-1}function hn(e,r){return e&&jr(r,Ce(r),e)}function Ee(e,r,t,i,l,n,o){var s;if(i&&(s=n?i(e,l,n,o):i(e)),s!==void 0)return s;if(!ue(e))return e;var p=Ne(e);if(p){if(s=In(e),!r)return _n(e,s)}else{var a=j(e),c=a==Ie||a==yr;if(Hn(e))return wn(e,r);if(a==We||a==Se||c&&!n){if(Cr(e))return n?e:{};if(s=Wn(c?{}:e),!r)return En(e,hn(s,e))}else{if(!O[a])return n?e:{};s=Dn(e,a,Ee,r)}}o||(o=new L);var h=o.get(e);if(h)return h;if(o.set(e,s),!p)var T=t?Sn(e):Ce(e);return Et(T||e,function(y,f){T&&(f=y,y=e[f]),Vr(s,f,Ee(y,r,t,i,f,e,o))}),s}function gn(e){return ue(e)?Rt(e):{}}function pn(e,r,t){var i=r(e);return Ne(e)?i:St(i,t(e))}function dn(e){return se.call(e)}function yn(e){if(!ue(e)||Cn(e))return!1;var r=Jr(e)||Cr(e)?Nt:bt;return r.test(M(e))}function mn(e){if(!Mr(e))return Mt(e);var r=[];for(var t in Object(e))V.call(e,t)&&t!="constructor"&&r.push(t);return r}function wn(e,r){if(r)return e.slice();var t=new e.constructor(e.length);return e.copy(t),t}function xe(e){var r=new e.constructor(e.byteLength);return new lr(r).set(new lr(e)),r}function bn(e,r){var t=r?xe(e.buffer):e.buffer;return new e.constructor(t,e.byteOffset,e.byteLength)}function Tn(e,r,t){var i=r?t(nr(e),!0):nr(e);return Nr(i,At,new e.constructor)}function $n(e){var r=new e.constructor(e.source,wt.exec(e));return r.lastIndex=e.lastIndex,r}function vn(e,r,t){var i=r?t(ir(e),!0):ir(e);return Nr(i,_t,new e.constructor)}function On(e){return cr?Object(cr.call(e)):{}}function An(e,r){var t=r?xe(e.buffer):e.buffer;return new e.constructor(t,e.byteOffset,e.length)}function _n(e,r){var t=-1,i=e.length;for(r||(r=Array(i));++t<i;)r[t]=e[t];return r}function jr(e,r,t,i){t||(t={});for(var l=-1,n=r.length;++l<n;){var o=r[l],s=i?i(t[o],e[o],o,t,e):void 0;Vr(t,o,s===void 0?e[o]:s)}return t}function En(e,r){return jr(e,Hr(e),r)}function Sn(e){return pn(e,Ce,Hr)}function le(e,r){var t=e.__data__;return Nn(r)?t[typeof r=="string"?"string":"hash"]:t.map}function q(e,r){var t=Wt(e,r);return yn(t)?t:void 0}var Hr=ur?De(ur,Object):Bn,j=dn;(ve&&j(new ve(new ArrayBuffer(1)))!=ie||Y&&j(new Y)!=te||Oe&&j(Oe.resolve())!=rr||Ae&&j(new Ae)!=ne||_e&&j(new _e)!=$e)&&(j=function(e){var r=se.call(e),t=r==We?e.constructor:void 0,i=t?M(t):void 0;if(i)switch(i){case Pt:return ie;case Bt:return te;case Jt:return rr;case Ft:return ne;case kt:return $e}return r});function In(e){var r=e.length,t=e.constructor(r);return r&&typeof e[0]=="string"&&V.call(e,"index")&&(t.index=e.index,t.input=e.input),t}function Wn(e){return typeof e.constructor=="function"&&!Mr(e)?gn(Ct(e)):{}}function Dn(e,r,t,i){var l=e.constructor;switch(r){case $r:return xe(e);case pr:case dr:return new l(+e);case ie:return bn(e,i);case vr:case Or:case Ar:case _r:case Er:case Sr:case Ir:case Wr:case Dr:return An(e,i);case te:return Tn(e,i,t);case mr:case br:return new l(e);case wr:return $n(e);case ne:return vn(e,i,t);case Tr:return On(e)}}function xn(e,r){return r=r==null?gr:r,!!r&&(typeof e=="number"||Tt.test(e))&&e>-1&&e%1==0&&e<r}function Nn(e){var r=typeof e;return r=="string"||r=="number"||r=="symbol"||r=="boolean"?e!=="__proto__":e===null}function Cn(e){return!!ar&&ar in e}function Mr(e){var r=e&&e.constructor,t=typeof r=="function"&&r.prototype||ae;return e===t}function M(e){if(e!=null){try{return Rr.call(e)}catch(r){}try{return e+""}catch(r){}}return""}function Rn(e){return Ee(e,!0,!0)}function Pr(e,r){return e===r||e!==e&&r!==r}function Vn(e){return jn(e)&&V.call(e,"callee")&&(!Vt.call(e,"callee")||se.call(e)==Se)}var Ne=Array.isArray;function Br(e){return e!=null&&Mn(e.length)&&!Jr(e)}function jn(e){return Pn(e)&&Br(e)}var Hn=Ht||Jn;function Jr(e){var r=ue(e)?se.call(e):"";return r==Ie||r==yr}function Mn(e){return typeof e=="number"&&e>-1&&e%1==0&&e<=gr}function ue(e){var r=typeof e;return!!e&&(r=="object"||r=="function")}function Pn(e){return!!e&&typeof e=="object"}function Ce(e){return Br(e)?cn(e):mn(e)}function Bn(){return[]}function Jn(){return!1}F.exports=Rn});var Lr=ke((kr,ge)=>{(function(e,r){"use strict";typeof ge=="object"&&typeof ge.exports=="object"?ge.exports=r():typeof define=="function"&&define.amd?define([],r):e.objectPath=r()})(kr,function(){"use strict";var e=Object.prototype.toString;function r(c,h){return c==null?!1:Object.prototype.hasOwnProperty.call(c,h)}function t(c){if(!c||n(c)&&c.length===0)return!0;if(typeof c!="string"){for(var h in c)if(r(c,h))return!1;return!0}return!1}function i(c){return e.call(c)}function l(c){return typeof c=="object"&&i(c)==="[object Object]"}var n=Array.isArray||function(c){return e.call(c)==="[object Array]"};function o(c){return typeof c=="boolean"||i(c)==="[object Boolean]"}function s(c){var h=parseInt(c);return h.toString()===c?h:c}function p(c){c=c||{};var h=function(d){return Object.keys(h).reduce(function(u,g){return g==="create"||typeof h[g]=="function"&&(u[g]=h[g].bind(h,d)),u},{})},T;c.includeInheritedProps?T=function(){return!0}:T=function(d,u){return typeof u=="number"&&Array.isArray(d)||r(d,u)};function y(d,u){if(T(d,u))return d[u]}var f;c.includeInheritedProps?f=function(d,u){typeof u!="string"&&typeof u!="number"&&(u=String(u));var g=y(d,u);if(u==="__proto__"||u==="prototype"||u==="constructor"&&typeof g=="function")throw new Error("For security reasons, object's magic properties cannot be set");return g}:f=function(d,u){return y(d,u)};function w(d,u,g,m){if(typeof u=="number"&&(u=[u]),!u||u.length===0)return d;if(typeof u=="string")return w(d,u.split(".").map(s),g,m);var b=u[0],A=f(d,b);return u.length===1?((A===void 0||!m)&&(d[b]=g),A):(A===void 0&&(typeof u[1]=="number"?d[b]=[]:d[b]={}),w(d[b],u.slice(1),g,m))}return h.has=function(d,u){if(typeof u=="number"?u=[u]:typeof u=="string"&&(u=u.split(".")),!u||u.length===0)return!!d;for(var g=0;g<u.length;g++){var m=s(u[g]);if(typeof m=="number"&&n(d)&&m<d.length||(c.includeInheritedProps?m in Object(d):r(d,m)))d=d[m];else return!1}return!0},h.ensureExists=function(d,u,g){return w(d,u,g,!0)},h.set=function(d,u,g,m){return w(d,u,g,m)},h.insert=function(d,u,g,m){var b=h.get(d,u);m=~~m,n(b)||(b=[],h.set(d,u,b)),b.splice(m,0,g)},h.empty=function(d,u){if(!t(u)&&d!=null){var g,m;if(g=h.get(d,u)){if(typeof g=="string")return h.set(d,u,"");if(o(g))return h.set(d,u,!1);if(typeof g=="number")return h.set(d,u,0);if(n(g))g.length=0;else if(l(g))for(m in g)T(g,m)&&delete g[m];else return h.set(d,u,null)}}},h.push=function(d,u){var g=h.get(d,u);n(g)||(g=[],h.set(d,u,g)),g.push.apply(g,Array.prototype.slice.call(arguments,2))},h.coalesce=function(d,u,g){for(var m,b=0,A=u.length;b<A;b++)if((m=h.get(d,u[b]))!==void 0)return m;return g},h.get=function(d,u,g){if(typeof u=="number"&&(u=[u]),!u||u.length===0)return d;if(d==null)return g;if(typeof u=="string")return h.get(d,u.split("."),g);var m=s(u[0]),b=f(d,m);return b===void 0?g:u.length===1?b:h.get(d[m],u.slice(1),g)},h.del=function(u,g){if(typeof g=="number"&&(g=[g]),u==null||t(g))return u;if(typeof g=="string")return h.del(u,g.split("."));var m=s(g[0]);if(f(u,m),!T(u,m))return u;if(g.length===1)n(u)?u.splice(m,1):delete u[m];else return h.del(u[m],g.slice(1));return u},h}var a=p();return a.create=p,a.withInheritedProps=p({includeInheritedProps:!0}),a})});var Xn={};it(Xn,{defaults:()=>Gr,jVar:()=>Yn,version:()=>Un});function S(e){return typeof e!="string"?e:e.length?[e]:[]}function E(e){if(e==null||typeof e!="object")return!1;let r=Object.getPrototypeOf(e);return r!==null&&r!==Object.prototype&&Object.getPrototypeOf(r)!==null?!1:!(Symbol.iterator in e)&&!(Symbol.toStringTag in e)}function $(e){return typeof e=="string"}function qe(e){return Number.isFinite(e)}function N(e){return Number.isSafeInteger(e)&&e>=0}function ee(e){return typeof e=="boolean"}function G(e){return e===null}function W(e){return e!=null}function Ue(e,r){return E(e)&&$(r)&&Object.prototype.hasOwnProperty.call(e,r)}var Ke={cb:void 0,i:!1,trimBeforeMatching:!1,trimCharsBeforeMatching:[],maxMismatches:0,firstMustMatch:!1,lastMustMatch:!1,hungry:!1},st=e=>e+1;function ot(e,r,t,i,l=!1,n=st){let o=typeof t=="function"?t():t;if(+r<0&&l&&o==="EOL")return o;let s=v(v({},Ke),i);if(r>=e.length&&!l)return!1;let p=l?1:t.length,a=0,c=!1,h=!1,T=!1,y=s.maxMismatches,f=r,w=!1,d=!1,u=!1;function g(){return a===1&&y<s.maxMismatches-1}for(;e[f];){let m=n(f);if(s.trimBeforeMatching&&e[f].trim()===""){if(!e[m]&&l&&t==="EOL")return!0;f=n(f);continue}if(s&&!s.i&&s.trimCharsBeforeMatching&&s.trimCharsBeforeMatching.includes(e[f])||s!=null&&s.i&&s.trimCharsBeforeMatching&&s.trimCharsBeforeMatching.map(A=>A.toLowerCase()).includes(e[f].toLowerCase())){if(l&&t==="EOL"&&!e[m])return!0;f=n(f);continue}let b=m>f?t[t.length-p]:t[p-1];if(!s.i&&e[f]===b||s.i&&e[f].toLowerCase()===b.toLowerCase()){if(w||(w=!0),T||(T=!0),p===t.length){if(d=!0,y!==s.maxMismatches)return!1}else p===1&&(u=!0);if(p-=1,a++,g())return!1;if(!p)return a!==t.length||y===s.maxMismatches||!c?f:!1}else if(!c&&!a&&(c=!0),s.maxMismatches&&y&&f){y-=1;for(let A=0;A<=y;A++){let I=m>f?t[t.length-p+1+A]:t[p-2-A],pe=e[n(f)];if(I&&(!s.i&&e[f]===I||s.i&&e[f].toLowerCase()===I.toLowerCase())&&(!s.firstMustMatch||p!==t.length)){if(a++,g())return!1;p-=2,w=!0;break}else if(pe&&I&&(!s.i&&pe===I||s.i&&pe.toLowerCase()===I.toLowerCase())&&(!s.firstMustMatch||p!==t.length)){if(!a&&!s.hungry)return!1;p-=1,w=!0;break}else if(I===void 0&&y>=0&&w&&(!s.firstMustMatch||d)&&(!s.lastMustMatch||u))return f}w||(h=f)}else return f===0&&p===1&&!s.lastMustMatch&&T?0:!1;if(h!==!1&&h!==f&&(h=!1),p<1)return f;f=n(f)}if(p>0)return l&&o==="EOL"?!0:s&&s.maxMismatches>=p&&T?h||0:!1}function Ge(e,r,t,i,l){var c,h;if(E(l)&&Ue(l,"trimBeforeMatching")&&l&&typeof l.trimBeforeMatching!="boolean")throw new Error(`string-match-left-right/${e}(): [THROW_ID_09] opts.trimBeforeMatching should be boolean!${Array.isArray(l.trimBeforeMatching)?" Did you mean to use opts.trimCharsBeforeMatching?":""}`);let n=v(v({},Ke),l);if(typeof n.trimCharsBeforeMatching=="string"&&(n.trimCharsBeforeMatching=S(n.trimCharsBeforeMatching)),n.trimCharsBeforeMatching=n.trimCharsBeforeMatching.map(T=>$(T)?T:String(T)),!$(r)||!r.length)return!1;if(!Number.isInteger(t)||t<0)throw new Error(`string-match-left-right/${e}(): [THROW_ID_03] the second argument should be a natural number. Currently it's of a type: ${typeof t}, equal to:
${JSON.stringify(t,null,4)}`);let o,s;if($(i))o=[i];else if(Array.isArray(i))o=i;else if(!i)o=i;else if(typeof i=="function")o=[],o.push(i);else throw new Error(`string-match-left-right/${e}(): [THROW_ID_05] the third argument, whatToMatch, is neither string nor array of strings! It's ${typeof i}, equal to:
${JSON.stringify(i,null,4)}`);if(l&&!E(l))throw new Error(`string-match-left-right/${e}(): [THROW_ID_06] the fourth argument, options object, should be a plain object. Currently it's of a type "${typeof l}", and equal to:
${JSON.stringify(l,null,4)}`);let p=0,a="";if(n!=null&&n.trimCharsBeforeMatching&&n.trimCharsBeforeMatching.some((T,y)=>T.length>1?(p=y,a=T,!0):!1))throw new Error(`string-match-left-right/${e}(): [THROW_ID_07] the fourth argument, options object contains trimCharsBeforeMatching. It was meant to list the single characters but one of the entries at index ${p} is longer than 1 character, ${a.length} (equals to ${a}). Please split it into separate characters and put into array as separate elements.`);if(!o||!Array.isArray(o)||Array.isArray(o)&&!o.length||Array.isArray(o)&&o.length===1&&$(o[0])&&!o[0].trim()){if(typeof n.cb=="function"){let y,f=t;if((e==="matchLeftIncl"||e==="matchRight")&&(f+=1),e[5]==="L")for(let g=f;g--;){let m=r[g];if((!n.trimBeforeMatching||n.trimBeforeMatching&&m!==void 0&&m.trim())&&(!((c=n.trimCharsBeforeMatching)!=null&&c.length)||m!==void 0&&!n.trimCharsBeforeMatching.includes(m))){y=g;break}}else if(e.startsWith("matchRight"))for(let g=f;g<r.length;g++){let m=r[g];if((!n.trimBeforeMatching||n.trimBeforeMatching&&m.trim())&&(!((h=n.trimCharsBeforeMatching)!=null&&h.length)||!n.trimCharsBeforeMatching.includes(m))){y=g;break}}if(y===void 0)return!1;let w=r[y],d=y+1,u="";return d&&d>0&&(u=r.slice(0,d)),e[5]==="L"||y&&y>0&&(u=r.slice(y)),n.cb(w,u,y)}let T="";throw l||(T=" More so, the whole options object, the fourth input argument, is missing!"),new Error(`string-match-left-right/${e}(): [THROW_ID_08] the third argument, "whatToMatch", was given as an empty string. This means, you intend to match purely by a callback. The callback was not set though, the opts key "cb" is not set!${T}`)}for(let T=0,y=o.length;T<y;T++){s=typeof o[T]=="function";let f=o[T],w,d,u="",g=t;e==="matchRight"?g+=1:e==="matchLeft"&&(g-=1);let m=ot(r,g,f,n,s,b=>e[5]==="L"?b-1:b+1);if(m&&s&&typeof f=="function"&&f()==="EOL")return f()&&(!n.cb||n.cb(w,u,d))?f():!1;if(Number.isInteger(m)&&(d=e.startsWith("matchLeft")?m-1:m+1,e[5]==="L"?u=r.slice(0,m):u=r.slice(d)),d<0&&(d=void 0),r[d]&&(w=r[d]),Number.isInteger(m)&&(!n.cb||n.cb(w,u,d)))return f}return!1}function P(e,r,t,i){return Ge("matchLeftIncl",e,r,t,i)}function D(e,r,t,i){return Ge("matchRightIncl",e,r,t,i)}function re(e,r=1){let t="\xA0";function i(n){return Array.from(n).reverse().join("")}function l(n,o,s){let p=s?`
`:"\r",a=s?"\r":`
`;if(!n)return n;let c=0,h=0,T="";for(let y=0,f=n.length;y<f;y++)(n[y]===p||n[y]===a&&n[y-1]!==p)&&h++,`\r
`.includes(n[y])||n[y]===t?(c=0,n[y]===t?T+=n[y]:n[y]===p?h<=o&&(T+=n[y],n[y+1]===a&&(T+=n[y+1],y++)):n[y]===a&&(n==null?void 0:n[y-1])!==p&&h<=o&&(T+=n[y])):(c++,!n[y+1]&&!h&&(T+=" "));return T}if(typeof e=="string"&&e.length){let n=1;typeof+r=="number"&&Number.isInteger(+r)&&+r>=0&&(n=+r);let o="",s="";if(!e.trim())o=e;else if(!e[0].trim()){for(let p=0,a=e.length;p<a;p++)if(e[p].trim()){o=e.slice(0,p);break}}if(e.trim()&&(e.slice(-1).trim()===""||e.slice(-1)===t)){for(let p=e.length;p--;)if(e[p].trim()){s=e.slice(p+1);break}}return`${l(o,n,!1)}${e.trim()}${i(l(i(s),n,!0))}`}return e}var lt={strictlyTwoElementsInRangeArrays:!1,progressFn:null};function B(e,r){if(!Array.isArray(e)||!e.length)return e;let t=v(v({},lt),r),i,l;if(t.strictlyTwoElementsInRangeArrays&&!e.every((s,p)=>!Array.isArray(s)||s.length!==2?(i=p,l=s.length,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${i}th range (${JSON.stringify(e[i],null,4)}) has not two but ${l} elements!`);if(!e.every((s,p)=>!Array.isArray(s)||!Number.isInteger(s[0])||s[0]<0||!Number.isInteger(s[1])||s[1]<0?(i=p,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${i}th range (${JSON.stringify(e[i],null,4)}) does not consist of only natural numbers!`);let n=e.length**2,o=0;return Array.from(e).sort((s,p)=>(t.progressFn&&(o+=1,t.progressFn(Math.floor(o*100/n))),s[0]===p[0]?s[1]<p[1]?-1:s[1]>p[1]?1:0:s[0]<p[0]?-1:1))}var Qe={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function ut(e,r){function t(a){return!!a&&typeof a=="object"&&!Array.isArray(a)}if(!Array.isArray(e)||!e.length)return null;let i;if(r)if(t(r)){if(i=v(v({},Qe),r),i.progressFn&&t(i.progressFn)&&!Object.keys(i.progressFn).length)i.progressFn=null;else if(i.progressFn&&typeof i.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] resolvedOpts.progressFn must be a function! It was given of a type: "${typeof i.progressFn}", equal to ${JSON.stringify(i.progressFn,null,4)}`);if(![1,2,"1","2"].includes(i.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] resolvedOpts.mergeType was customised to a wrong thing! It was given of a type: "${typeof i.mergeType}", equal to ${JSON.stringify(i.mergeType,null,4)}`);if(typeof i.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] resolvedOpts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof i.joinRangesThatTouchEdges}", equal to ${JSON.stringify(i.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(r,null,4)} (type ${typeof r})`);else i=v({},Qe);let l=e.filter(a=>Array.isArray(a)).map(a=>[...a]).filter(a=>a[2]!==void 0||a[0]!==a[1]),n,o,s;i.progressFn?n=B(l,{progressFn:a=>{s=Math.floor(a/5),s!==o&&(o=s,i.progressFn(s))}}):n=B(l);let p=n.length-1;for(let a=p;a>0;a--)i.progressFn&&(s=Math.floor((1-a/p)*78)+21,s!==o&&s>o&&(o=s,i.progressFn(s))),(n[a][0]<=n[a-1][0]||!i.joinRangesThatTouchEdges&&n[a][0]<n[a-1][1]||i.joinRangesThatTouchEdges&&n[a][0]<=n[a-1][1])&&(n[a-1][0]=Math.min(n[a][0],n[a-1][0]),n[a-1][1]=Math.max(n[a][1],n[a-1][1]),n[a][2]!==void 0&&(n[a-1][0]>=n[a][0]||n[a-1][1]<=n[a][1])&&n[a-1][2]!==null&&(n[a][2]===null&&n[a-1][2]!==null?n[a-1][2]=null:n[a-1][2]!=null?+i.mergeType==2&&n[a-1][0]===n[a][0]?n[a-1][2]=n[a][2]:n[a-1][2]+=n[a][2]:n[a-1][2]=n[a][2]),n.splice(a,1),a=n.length);return n.length?n:null}var ft={limitToBeAddedWhitespace:!1,limitLinebreaksCount:1,mergeType:1},Q=class{constructor(e){me(this,"ranges");me(this,"opts");let r=v(v({},ft),e);if(r.mergeType&&r.mergeType!==1&&r.mergeType!==2)if($(r.mergeType)&&r.mergeType.trim()==="1")r.mergeType=1;else if($(r.mergeType)&&r.mergeType.trim()==="2")r.mergeType=2;else throw new Error(`ranges-push: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof r.mergeType}", equal to ${JSON.stringify(r.mergeType,null,4)}`);this.opts=r,this.ranges=[]}add(e,r,t){var n;if(e==null&&r==null)return;if(W(e)&&!W(r)){if(Array.isArray(e)){if(e.length){if(e.some(o=>Array.isArray(o))){e.forEach(o=>{Array.isArray(o)&&this.add(...o)});return}e.length&&N(+e[0])&&N(+e[1])&&this.add(...e)}return}throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_12] the first input argument, "from" is set (${JSON.stringify(e,null,0)}) but second-one, "to" is not (${JSON.stringify(r,null,0)})`)}else if(!W(e)&&W(r))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_13] the second input argument, "to" is set (${JSON.stringify(r,null,0)}) but first-one, "from" is not (${JSON.stringify(e,null,0)})`);let i=+e,l=+r;if(N(t)&&(t=String(t)),N(i)&&N(l)){if(W(t)&&!$(t)&&!N(t))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_08] The third argument, the value to add, was given not as string but ${typeof t}, equal to:
${JSON.stringify(t,null,4)}`);if(W(this.ranges)&&Array.isArray(this.last())&&i===this.last()[1]){if(this.last()[1]=l,this.last()[2],this.last()[2]!==null&&W(t)){let o=this.last()[2]&&this.last()[2].length&&(!((n=this.opts)!=null&&n.mergeType)||this.opts.mergeType===1)?`${this.last()[2]}${t}`:t;this.opts.limitToBeAddedWhitespace&&(o=re(o,this.opts.limitLinebreaksCount)),$(o)&&!o.length||(this.last()[2]=o)}}else{this.ranges||(this.ranges=[]);let o=t!==void 0&&!($(t)&&!t.length)?[i,l,t&&this.opts.limitToBeAddedWhitespace?re(t,this.opts.limitLinebreaksCount):t]:[i,l];this.ranges.push(o)}}else throw N(i)&&i>=0?new TypeError(`ranges-push/Ranges/add(): [THROW_ID_10] "to" value, the second input argument, must be a natural number or zero! Currently it's of a type "${typeof l}" equal to: ${JSON.stringify(l,null,4)}`):new TypeError(`ranges-push/Ranges/add(): [THROW_ID_09] "from" value, the first input argument, must be a natural number or zero! Currently it's of a type "${typeof i}" equal to: ${JSON.stringify(i,null,4)}`)}push(e,r,t){this.add(e,r,t)}current(){return Array.isArray(this.ranges)&&this.ranges.length?(this.ranges=ut(this.ranges,{mergeType:this.opts.mergeType}),this.ranges&&this.opts.limitToBeAddedWhitespace?this.ranges.map(e=>W(e[2])?[e[0],e[1],re(e[2],this.opts.limitLinebreaksCount)]:e):this.ranges):null}wipe(){this.ranges=[]}replace(e){if(Array.isArray(e)&&e.length)if(Array.isArray(e[0])&&N(e[0][0]))this.ranges=Array.from(e);else throw new Error(`ranges-push/Ranges/replace(): [THROW_ID_11] Single range was given but we expected array of arrays! The first element, ${JSON.stringify(e[0],null,4)} should be an array and its first element should be an integer, a string index.`);else this.ranges=[]}last(){return Array.isArray(this.ranges)&&this.ranges.length?this.ranges[this.ranges.length-1]:null}};var ze={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function Ze(e,r){function t(a){return!!a&&typeof a=="object"&&!Array.isArray(a)}if(!Array.isArray(e)||!e.length)return null;let i;if(r)if(t(r)){if(i=v(v({},ze),r),i.progressFn&&t(i.progressFn)&&!Object.keys(i.progressFn).length)i.progressFn=null;else if(i.progressFn&&typeof i.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof i.progressFn}", equal to ${JSON.stringify(i.progressFn,null,4)}`);if(![1,2,"1","2"].includes(i.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof i.mergeType}", equal to ${JSON.stringify(i.mergeType,null,4)}`);if(typeof i.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof i.joinRangesThatTouchEdges}", equal to ${JSON.stringify(i.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(r,null,4)} (type ${typeof r})`);else i=v({},ze);let l=e.filter(a=>Array.isArray(a)).map(a=>[...a]).filter(a=>a[2]!==void 0||a[0]!==a[1]),n,o,s;i.progressFn?n=B(l,{progressFn:a=>{s=Math.floor(a/5),s!==o&&(o=s,i.progressFn(s))}}):n=B(l);let p=n.length-1;for(let a=p;a>0;a--)i.progressFn&&(s=Math.floor((1-a/p)*78)+21,s!==o&&s>o&&(o=s,i.progressFn(s))),(n[a][0]<=n[a-1][0]||!i.joinRangesThatTouchEdges&&n[a][0]<n[a-1][1]||i.joinRangesThatTouchEdges&&n[a][0]<=n[a-1][1])&&(n[a-1][0]=Math.min(n[a][0],n[a-1][0]),n[a-1][1]=Math.max(n[a][1],n[a-1][1]),n[a][2]!==void 0&&(n[a-1][0]>=n[a][0]||n[a-1][1]<=n[a][1])&&n[a-1][2]!==null&&(n[a][2]===null&&n[a-1][2]!==null?n[a-1][2]=null:n[a-1][2]!=null?+i.mergeType==2&&n[a-1][0]===n[a][0]?n[a-1][2]=n[a][2]:n[a-1][2]+=n[a][2]:n[a-1][2]=n[a][2]),n.splice(a,1),a=n.length);return n.length?n:null}var ct=!0,we="Invariant failed";function Ye(e,r){if(!e){if(ct)throw new Error(we);var t=typeof r=="function"?r():r,i=t?"".concat(we,": ").concat(t):we;throw new Error(i)}}function J(e,r,t){let i=0,l=0;if(arguments.length===0)throw new Error("ranges-apply: [THROW_ID_01] inputs missing!");if(typeof e!="string")throw new TypeError(`ranges-apply: [THROW_ID_02] first input argument must be a string! Currently it's: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(r&&!Array.isArray(r))throw new TypeError(`ranges-apply: [THROW_ID_03] second input argument must be an array (or null)! Currently it's: ${typeof r}, equal to: ${JSON.stringify(r,null,4)}`);if(t&&typeof t!="function")throw new TypeError(`ranges-apply: [THROW_ID_04] the third input argument must be a function (or falsey)! Currently it's: ${typeof t}, equal to: ${JSON.stringify(t,null,4)}`);if(!r||!r.filter(c=>c).length)return e;let n;Array.isArray(r)&&Number.isInteger(r[0])&&Number.isInteger(r[1])?n=[Array.from(r)]:n=Array.from(r);let o=n.length,s=0;n.filter(c=>c).forEach((c,h)=>{if(t&&(i=Math.floor(s/o*10),i!==l&&(l=i,t(i))),!Array.isArray(c))throw new TypeError(`ranges-apply: [THROW_ID_05] ranges array, second input arg., has ${h}th element not an array: ${JSON.stringify(c,null,4)}, which is ${typeof c}`);if(!Number.isInteger(c[0])){if(!Number.isInteger(+c[0])||+c[0]<0)throw new TypeError(`ranges-apply: [THROW_ID_06] ranges array, second input arg. has ${h}th element, array ${JSON.stringify(c,null,0)}. Its first element is not an integer, string index, but ${typeof c[0]}, equal to: ${JSON.stringify(c[0],null,4)}.`);n[h][0]=+n[h][0]}if(!Number.isInteger(c[1])){if(!Number.isInteger(+c[1])||+c[1]<0)throw new TypeError(`ranges-apply: [THROW_ID_07] ranges array, second input arg. has ${h}th element, array ${JSON.stringify(c,null,0)}. Its second element is not an integer, string index, but ${typeof c[1]}, equal to: ${JSON.stringify(c[1],null,4)}.`);n[h][1]=+n[h][1]}s+=1});let p=Ze(n,{progressFn:c=>{t&&(i=10+Math.floor(c/10),i!==l&&(l=i,t(i)))}});Ye(p);let a=p.length;if(a>0){let c=e.slice(p[a-1][1]);e=p.reduce((h,T,y,f)=>{t&&(i=20+Math.floor(y/a*80),i!==l&&(l=i,t(i)));let w=y===0?0:f[y-1][1],d=f[y][0];return`${h}${e.slice(w,d)}${f[y][2]||""}`},""),e+=c}return e}var ht={classicTrim:!1,cr:!1,lf:!1,tab:!1,space:!0,nbsp:!1};function z(e,r){if(typeof e!="string")throw new Error(`string-trim-spaces-only: [THROW_ID_01] input must be string! It was given as ${typeof e}, equal to:
${JSON.stringify(e,null,4)}`);let t=v(v({},ht),r);function i(o){return t.classicTrim&&!o.trim()||!t.classicTrim&&(t.space&&o===" "||t.cr&&o==="\r"||t.lf&&o===`
`||t.tab&&o==="	"||t.nbsp&&o==="\xA0")}let l,n;if(e.length){if(i(e[0]))for(let o=0,s=e.length;o<s;o++){if(!i(e[o])){l=o;break}if(o===e.length-1)return{res:"",ranges:[[0,e.length]]}}if(i(e[e.length-1])){for(let o=e.length;o--;)if(!i(e[o])){n=o+1;break}}return l?n?{res:e.slice(l,n),ranges:[[0,l],[n,e.length]]}:{res:e.slice(l),ranges:[[0,l]]}:n?{res:e.slice(0,n),ranges:[[n,e.length]]}:{res:e,ranges:[]}}return{res:"",ranges:[]}}var gt={heads:["{{"],tails:["}}"]};function Xe(e,r){let t=Object.prototype.hasOwnProperty;if(e===void 0)throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_01] The input is missing!");if(typeof e!="string")return e;if(r&&!E(r))throw new Error(`string-remove-duplicate-heads-tails: [THROW_ID_03] The given options are not a plain object but ${typeof r}!`);let i=v({},r);if(i&&t.call(i,"heads"))if(S(i.heads).every(w=>typeof w=="string"||Array.isArray(w)))typeof i.heads=="string"&&(i.heads=S(i.heads));else throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_04] The resolvedOpts.heads contains elements which are not string-type!");if(i&&t.call(i,"tails"))if(S(i.tails).every(w=>typeof w=="string"||Array.isArray(w)))typeof i.tails=="string"&&(i.tails=S(i.tails));else throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_05] The resolvedOpts.tails contains elements which are not string-type!");let l=z(e).res;if(l.length===0)return e;e=l;let n=v(v({},gt),i);n.heads=n.heads.map(w=>w.trim()),n.tails=n.tails.map(w=>w.trim());let o=!1,s=!1,p=new Q({limitToBeAddedWhitespace:!0}),a=new Q({limitToBeAddedWhitespace:!0}),c=!0,h=!0,T="";function y(w,d){let u;return D(w,0,d.heads,{trimBeforeMatching:!0,cb:(g,m,b)=>(u=b,!0)})&&D(w,u,d.tails,{trimBeforeMatching:!0,cb:(g,m,b)=>(u=b,!0)})?w.slice(u):w}for(;e!==y(e,n);)e=z(y(e,n)).res;function f(w,d){let u;return!P(w,w.length-1,d.tails,{trimBeforeMatching:!0,cb:(g,m,b)=>(u=b,!0)})||!u?w:P(w,u,d.heads,{trimBeforeMatching:!0,cb:(g,m,b)=>(u=b,!0)})?w.slice(0,u+1):w}for(;e!==f(e,n);)e=z(f(e,n)).res;if(!n.heads.length||!D(e,0,n.heads,{trimBeforeMatching:!0})||!n.tails.length||!P(e,e.length-1,n.tails,{trimBeforeMatching:!0}))return z(e).res;for(let w=0,d=e.length;w<d;w++)if(e[w].trim()!==""){let u;if(D(e,w,n.heads,{trimBeforeMatching:!0,cb:(g,m,b)=>(u=b,!0)})&&u){h=!0,c&&(c=!0);let g;D(e,u,n.tails,{trimBeforeMatching:!0,cb:(m,b,A)=>(g=A,!0)})&&p.push(w,g),a.current()&&o&&T!=="tails"&&p.push(a.current()),o||a.current()&&(p.push(a.current()),a.wipe()),a.push(w,u),T="heads",w=u-1;continue}if(D(e,w,n.tails,{trimBeforeMatching:!0,cb:(g,m,b)=>(u=Number.isInteger(b)?b:e.length,!0)})&&u){h=!0,c?(T==="heads"&&a.wipe(),c=!1):a.push(w,u),T="tails",w=u-1;continue}c&&(c=!0),h&&!o?(o=!0,h=!1):h&&!s?(s=!0,c=!0,h=!1,T==="heads"&&a.wipe()):h&&s&&a.wipe()}return a.current()&&p.push(a.current()),p.current()?J(e,p.current()).trim():e.trim()}var er={fromIndex:0,throwWhenSomethingWrongIsDetected:!0,allowWholeValueToBeOnlyHeadsOrTails:!0,source:"string-find-heads-tails",matchHeadsAndTailsStrictlyInPairsByTheirOrder:!1,relaxedAPI:!1};function be(e,r,t,i){if(W(i)&&!E(i))throw new TypeError(`string-find-heads-tails: [THROW_ID_01] the fourth input argument, an Optional Options Object, must be a plain object! Currently it's equal to: ${i} (type: ${typeof i})`);let l=v(v({},er),i);if($(l.fromIndex)&&/^\d*$/.test(l.fromIndex))l.fromIndex=Number(l.fromIndex);else if(!Number.isInteger(l.fromIndex)||l.fromIndex<0)throw new TypeError(`${l.source} [THROW_ID_18] the fourth input argument must be a natural number or zero! Currently it's: ${l.fromIndex}`);if(!$(e)||e.length===0){if(l.relaxedAPI)return[];throw new TypeError(`string-find-heads-tails: [THROW_ID_02] the first input argument, input string, must be a non-zero-length string! Currently it's: ${typeof e}, equal to: ${e}`)}let n,o;if(!$(r)&&!Array.isArray(r)){if(l.relaxedAPI)return[];throw new TypeError(`string-find-heads-tails: [THROW_ID_03] the second input argument, heads, must be either a string or an array of strings! Currently it's: ${typeof r}, equal to:
${JSON.stringify(r,null,4)}`)}else if($(r))if(r.length===0){if(l.relaxedAPI)return[];throw new TypeError("string-find-heads-tails: [THROW_ID_04] the second input argument, heads, must be a non-empty string! Currently it's empty.")}else r=S(r);else if(Array.isArray(r))if(r.length===0){if(l.relaxedAPI)return[];throw new TypeError("string-find-heads-tails: [THROW_ID_05] the second input argument, heads, must be a non-empty array and contain at least one string! Currently it's empty.")}else if(r.every((f,w)=>(n=f,o=w,$(f)))){if(!r.every((f,w)=>(o=w,$(f)&&f.length&&f.trim()!=="")))if(l.relaxedAPI){if(r=r.filter(f=>$(f)&&f.length),r.length===0)return[]}else throw new TypeError(`string-find-heads-tails: [THROW_ID_07] the second input argument, heads, should not contain empty strings! For example, there's one detected at index ${o} of heads array:
${JSON.stringify(r,null,4)}.`)}else if(l.relaxedAPI){if(r=r.filter(f=>$(f)&&f.length),r.length===0)return[]}else throw new TypeError(`string-find-heads-tails: [THROW_ID_06] the second input argument, heads, contains non-string elements! For example, element at ${o}th index is ${typeof n}, equal to:
${JSON.stringify(n,null,4)}. Whole heads array looks like:
${JSON.stringify(r,null,4)}`);if(!$(t)&&!Array.isArray(t)){if(l.relaxedAPI)return[];throw new TypeError(`string-find-heads-tails: [THROW_ID_08] the third input argument, tails, must be either a string or an array of strings! Currently it's: ${typeof t}, equal to:
${JSON.stringify(t,null,4)}`)}else if($(t))if(t.length===0){if(l.relaxedAPI)return[];throw new TypeError("string-find-heads-tails: [THROW_ID_09] the third input argument, tails, must be a non-empty string! Currently it's empty.")}else t=S(t);else if(Array.isArray(t))if(t.length===0){if(l.relaxedAPI)return[];throw new TypeError("string-find-heads-tails: [THROW_ID_10] the third input argument, tails, must be a non-empty array and contain at least one string! Currently it's empty.")}else if(t.every((f,w)=>(n=f,o=w,$(f)))){if(!t.every((f,w)=>(o=w,$(f)&&f.length&&f.trim()!=="")))if(l.relaxedAPI){if(t=t.filter(f=>$(f)&&f.length),t.length===0)return[]}else throw new TypeError(`string-find-heads-tails: [THROW_ID_12] the third input argument, tails, should not contain empty strings! For example, there's one detected at index ${o}. Whole tails array is equal to:
${JSON.stringify(t,null,4)}`)}else if(l.relaxedAPI){if(t=t.filter(f=>$(f)&&f.length),t.length===0)return[]}else throw new TypeError(`string-find-heads-tails: [THROW_ID_11] the third input argument, tails, contains non-string elements! For example, element at ${o}th index is ${typeof n}, equal to:
${JSON.stringify(n,null,4)}. Whole tails array is equal to:
${JSON.stringify(t,null,4)}`);let s=l.source===er.source;if(l.throwWhenSomethingWrongIsDetected&&!l.allowWholeValueToBeOnlyHeadsOrTails){if(S(r).includes(e))throw new Error(`${l.source}${s?": [THROW_ID_16]":""} the whole input string can't be equal to ${$(r)?"":"one of "}heads (${e})!`);if(S(t).includes(e))throw new Error(`${l.source}${s?": [THROW_ID_17]":""} the whole input string can't be equal to ${$(t)?"":"one of "}tails (${e})!`)}let p=r.concat(t).map(f=>f.charAt(0)).reduce((f,w)=>w.charCodeAt(0)>f[1]?[f[0],w.charCodeAt(0)]:w.charCodeAt(0)<f[0]?[w.charCodeAt(0),f[1]]:f,[r[0].charCodeAt(0),r[0].charCodeAt(0)]),a=[],c=!1,h={},T="",y;for(let f=l.fromIndex,w=e.length;f<w;f++){let d=e[f].charCodeAt(0);if(d<=p[1]&&d>=p[0]){let u=D(e,f,r);if(u&&l.matchHeadsAndTailsStrictlyInPairsByTheirOrder){for(let m=r.length;m--;)if(r[m]===u){y=m;break}}if($(u))if(c){if(l.throwWhenSomethingWrongIsDetected)throw new TypeError(`${l.source}${s?": [THROW_ID_19]":""} When processing "${e}", we found heads (${e.slice(f,f+u.length)}) starting at character with index number "${f}" and there was another set of heads before it! Generally speaking, there should be "heads-tails-heads-tails", not "heads-heads-tails"!
We're talking about the area of the code:


--------------------------------------starts
${e.slice(Math.max(f-200,0),f)}
      \x1B[33m------->\x1B[39m ${`\x1B[31m${e.slice(f,f+u.length)}\x1B[39m`} \x1B[33m<-------\x1B[39m
${e.slice(f+u.length,Math.min(w,f+200))}
--------------------------------------ends


To turn off this error being thrown, set resolvedOpts.throwWhenSomethingWrongIsDetected to Boolean false.`)}else{h={},h.headsStartAt=f,h.headsEndAt=f+u.length,c=!0,f+=u.length-1,T&&(T="");continue}let g=D(e,f,t);if(c&&g&&l.matchHeadsAndTailsStrictlyInPairsByTheirOrder&&y!==void 0&&t[y]!==void 0&&t[y]!==g){let m;for(let b=t.length;b--;)if(t[b]===g){m=b;break}throw new TypeError(`${l.source}${s?": [THROW_ID_20]":""} When processing "${e}", we had "resolvedOpts.matchHeadsAndTailsStrictlyInPairsByTheirOrder" on. We found heads (${r[y]}) but the tails the followed it were not of the same index, ${y} (${t[y]}) but ${m} (${g}).`)}if($(g))if(c){h.tailsStartAt=f,h.tailsEndAt=f+g.length,a.push(h),h={},c=!1,f+=g.length-1;continue}else l.throwWhenSomethingWrongIsDetected&&(T=`${l.source}${s?": [THROW_ID_21]":""} When processing "${e}", we found tails (${e.slice(f,f+g.length)}) starting at character with index number "${f}" but there were no heads preceding it. That's very naughty!`)}if(l.throwWhenSomethingWrongIsDetected&&f===w-1){if(Object.keys(h).length!==0)throw new TypeError(`${l.source}${s?": [THROW_ID_22]":""} When processing "${e}", we reached the end of the string and yet didn't find any tails (${JSON.stringify(t,null,4)}) to match the last detected heads (${e.slice(h.headsStartAt,h.headsEndAt)})!`);if(T)throw new Error(T)}}return a}var fe=ye(Re(),1);function Fn(e){if(e.includes(".")){let r=e.lastIndexOf(".");if(!e.slice(0,r).includes("."))return e.slice(0,r);for(let t=r-1;t--;)if(e[t]===".")return e.slice(t+1,r)}return null}var Ve=Fn;function ce(e,r){let t={now:!1};function i(l,n,o,s){let p=(0,fe.default)(l),a,c=v({depth:-1,path:""},o);if(c.depth+=1,Array.isArray(p))for(let h=0,T=p.length;h<T&&!s.now;h++){let y=c.path?`${c.path}.${h}`:`${h}`;p[h]!==void 0?(c.parent=(0,fe.default)(p),c.parentType="array",c.parentKey=Ve(y),a=i(n(p[h],void 0,K(v({},c),{path:y}),s),n,K(v({},c),{path:y}),s),Number.isNaN(a)&&h<p.length?(p.splice(h,1),h-=1):p[h]=a):p.splice(h,1)}else if(E(p))for(let h in p){if(s.now&&h!=null)break;let T=c.path?`${c.path}.${h}`:h;c.depth===0&&h!=null&&(c.topmostKey=h),c.parent=(0,fe.default)(p),c.parentType="object",c.parentKey=Ve(T),a=i(n(h,p[h],K(v({},c),{path:T}),s),n,K(v({},c),{path:T}),s),Number.isNaN(a)?delete p[h]:p[h]=a}return p}return i(e,r,{},t)}function je(e){if(typeof e!="string")throw new TypeError("Expected a string");return e.replace(/[|\\{}()[\]^$+*?.]/g,"\\$&").replace(/-/g,"\\x2d")}var He=new Map,Fr=(e,r)=>{if(!Array.isArray(e))switch(typeof e){case"string":e=[e];break;case"undefined":e=[];break;default:throw new TypeError(`Expected '${r}' to be a string or an array, but got a type of '${typeof e}'`)}return e.filter(t=>{if(typeof t!="string"){if(typeof t>"u")return!1;throw new TypeError(`Expected '${r}' to be an array of strings, but found a type of '${typeof t}' in the array`)}return!0})},kn=(e,r)=>{r=v({caseSensitive:!1},r);let t=e+JSON.stringify(r);if(He.has(t))return He.get(t);let i=e[0]==="!";i&&(e=e.slice(1)),e=je(e).replace(/\\\*/g,"[\\s\\S]*");let l=new RegExp(`^${e}$`,r.caseSensitive?"":"i");return l.negated=i,He.set(t,l),l},Ln=(e,r,t,i)=>{if(e=Fr(e,"inputs"),r=Fr(r,"patterns"),r.length===0)return[];r=r.map(o=>kn(o,t));let{allPatterns:l}=t||{},n=[];for(let o of e){let s,p=[...r].fill(!1);for(let[a,c]of r.entries())if(c.test(o)&&(p[a]=!0,s=!c.negated,!s))break;if(!(s===!1||s===void 0&&r.some(a=>!a.negated)||l&&p.some((a,c)=>!a&&!r[c].negated))&&(n.push(o),i))break}return n};function he(e,r,t){return Ln(e,r,t,!0).length>0}var Me=ye(Re(),1);function Pe(e,r,t){let i;t!==void 0&&(i=Array.isArray(t)?(0,Me.default)(t):[(0,Me.default)(t)]);let l=[],n=ce(e,(o,s,p)=>{let a=s!==void 0?s:o;if(s!==void 0&&he(o,r,{caseSensitive:!0})){if(i===void 0)l.push({val:s,path:p.path});else if(i.length)return i.shift()}return a});return i===void 0?l:n}var x=ye(Lr(),1);var qr="12.0.11";var Un=qr,Kn=Object.prototype.hasOwnProperty,Gr={heads:"%%_",tails:"_%%",headsNoWrap:"%%-",tailsNoWrap:"-%%",lookForDataContainers:!0,dataContainerIdentifierTails:"_data",wrapHeadsWith:"",wrapTailsWith:"",dontWrapVars:[],preventDoubleWrapping:!0,wrapGlobalFlipSwitch:!0,noSingleMarkers:!1,resolveToBoolIfAnyValuesContainBool:!0,resolveToFalseIfAnyValuesContainBool:!0,throwWhenNonStringInsertedInString:!1,allowUnresolved:!1};function _(e){return $(e)?e.trim():e}function Gn(e){if($(e)&&e.length&&e.indexOf(".")!==-1){for(let r=0,t=e.length;r<t;r++)if(e[r]===".")return e.slice(0,r)}return e}function Qn(e){if($(e)&&e.length&&e.indexOf(".")!==-1){for(let r=0,t=e.length;r<t;r++)if(e[r]===".")return e.slice(r+1)}return e}function Qr(e){if($(e)&&e.length&&e.indexOf(".")!==-1){for(let r=e.length;r--;)if(e[r]===".")return e.slice(0,r)}return e}function Ur(e){if($(e)&&e.length&&e.indexOf(".")!==-1){for(let r=e.length;r--;)if(e[r]===".")return e.slice(r+1)}return e}function Be(e,r){return!$(e)||!e.trim()?!1:!!(e.includes(r.heads)||e.includes(r.tails)||$(r.headsNoWrap)&&r.headsNoWrap.length&&e.includes(r.headsNoWrap)||$(r.tailsNoWrap)&&r.tailsNoWrap.length&&e.includes(r.tailsNoWrap))}function zn(e,r,t){let i,l;return $(e)&&e.length&&D(e,0,r,{trimBeforeMatching:!0,cb:(n,o,s)=>(i=s,!0)})&&P(e,e.length-1,t,{trimBeforeMatching:!0,cb:(n,o,s)=>(l=(s||0)+1,!0)})?e.slice(i,l):e}function Kr(e,r,t=!1,i,l,n){if(r.wrapHeadsWith||(r.wrapHeadsWith=""),r.wrapTailsWith||(r.wrapTailsWith=""),$(e)&&!t&&r.wrapGlobalFlipSwitch&&!r.dontWrapVars.some(o=>he(n,o))&&(!r.preventDoubleWrapping||r.preventDoubleWrapping&&$(e)&&!e.includes(r.wrapHeadsWith)&&!e.includes(r.wrapTailsWith)))return`${r.wrapHeadsWith}${e}${r.wrapTailsWith}`;if(t){if(!$(e))return e;let o=Xe(e,{heads:r.wrapHeadsWith,tails:r.wrapTailsWith});return $(o)?zn(o,r.wrapHeadsWith,r.wrapTailsWith):o}return e}function Zn(e,r,t,i){let l;if(t.indexOf(".")!==-1){let n=t,o=!0;if(i.lookForDataContainers&&$(i.dataContainerIdentifierTails)&&i.dataContainerIdentifierTails.length&&!n.endsWith(i.dataContainerIdentifierTails)){let s=x.default.get(e,n+i.dataContainerIdentifierTails);E(s)&&x.default.get(s,r)&&(l=x.default.get(s,r),o=!1)}for(;o&&n.indexOf(".")!==-1;){if(n=Qr(n),Ur(n)===r)throw new Error(`json-variables/findValues(): [THROW_ID_20] While trying to resolve: "${r}" at path "${t}", we encountered a closed loop. The parent key "${Ur(n)}" is called the same as the variable "${r}" we're looking for.`);if(i.lookForDataContainers&&$(i.dataContainerIdentifierTails)&&i.dataContainerIdentifierTails.length&&!n.endsWith(i.dataContainerIdentifierTails)){let s=x.default.get(e,n+i.dataContainerIdentifierTails);E(s)&&x.default.get(s,r)&&(l=x.default.get(s,r),o=!1)}if(l===void 0){let s=x.default.get(e,n);E(s)&&x.default.get(s,r)&&(l=x.default.get(s,r),o=!1)}}}if(l===void 0){let n=x.default.get(e,r);n!==void 0&&(l=n)}if(l===void 0)if(r.indexOf(".")===-1){let n=Pe(e,r);if(n.length){for(let o=0,s=n.length;o<s;o++)if($(n[o].val)||ee(n[o].val)||G(n[o].val)){l=n[o].val;break}else if(qe(n[o].val)){l=String(n[o].val);break}else if(Array.isArray(n[o].val)){l=n[o].val.join("");break}}}else{let n=Pe(e,Gn(r));if(n.length)for(let o=0,s=n.length;o<s;o++){let p=x.default.get(n[o].val,Qn(r));p&&$(p)&&(l=p)}}return l}function zr(e,r,t,i,l=[]){if(l.includes(t)){let y="";if(l.length>1){let f=` \u2192
`;y=l.reduce((w,d,u)=>w+(u===0?"":f)+(d===t?"\u{1F4A5} ":"  ")+d,` Here's the path we travelled up until we hit the recursion:

`),y+=`${f}\u{1F4A5} ${t}`}throw new Error(`json-variables/resolveString(): [THROW_ID_19] While trying to resolve: "${r}" at path "${t}", we encountered a closed loop, the key is referencing itself."${y}`)}let n={},o=Array.from(l);o.push(t);let s=new Q;function p(y,f,w){for(let d=0,u=y.length;d<u;d++){let g=y[d],m=r.slice(g.headsEndAt,g.tailsStartAt);if(m.length===0)s.push(g.headsStartAt,g.tailsEndAt);else if(Kn.call(n,m)&&$(n[m]))s.push(g.headsStartAt,g.tailsEndAt,n[m]);else{let b=Zn(e,m.trim(),t,i);if(b===void 0)if(i.allowUnresolved===!0)b="";else if($(i.allowUnresolved))b=i.allowUnresolved;else throw new Error(`json-variables/processHeadsAndTails(): [THROW_ID_18] We couldn't find the value to resolve the variable ${r.slice(g.headsEndAt,g.tailsStartAt)}. We're at path: "${t}".`);if(!w&&i.throwWhenNonStringInsertedInString&&!$(b))throw new Error(`json-variables/processHeadsAndTails(): [THROW_ID_23] While resolving the variable ${r.slice(g.headsEndAt,g.tailsStartAt)} at path ${t}, it resolved into a non-string value, ${JSON.stringify(b,null,4)}. This is happening because options setting "throwWhenNonStringInsertedInString" is active (set to "true").`);if(ee(b)){if(i.resolveToBoolIfAnyValuesContainBool)return s.wipe(),i.resolveToFalseIfAnyValuesContainBool?!1:b;b=""}else{if(G(b)&&w)return s.wipe(),b;Array.isArray(b)?b=String(b.join("")):G(b)?b="":b=String(b)}let A=t.includes(".")?`${Qr(t)}.${m}`:m;if(Be(b,i)){let I=Kr(zr(e,b,A,i,o),i,f,o,A,m.trim());$(I)&&s.push(g.headsStartAt,g.tailsEndAt,I)}else{n[m]=b;let I=Kr(b,i,f,o,A,m.trim());$(I)&&s.push(g.headsStartAt,g.tailsEndAt,I)}}}}let a;try{a=be(r,i.heads,i.tails,{source:"",throwWhenSomethingWrongIsDetected:!1})}catch(y){throw new Error(`json-variables/resolveString(): [THROW_ID_17] While trying to resolve string: "${r}" at path ${t}, something wrong with heads and tails was detected! Here's the internal error message:
${y}`)}let c=!1;a.length===1&&J(r,[[a[0].headsStartAt,a[0].tailsEndAt]]).trim()===""&&(c=!0);let h=p(a,!1,c);if(typeof h=="boolean"||h===null)return h;try{a=be(r,i.headsNoWrap,i.tailsNoWrap,{source:"",throwWhenSomethingWrongIsDetected:!1})}catch(y){throw new Error(`json-variables/resolveString(): [THROW_ID_22] While trying to resolve string: "${r}" at path ${t}, something wrong with no-wrap heads and no-wrap tails was detected! Here's the internal error message:
${y}`)}a.length===1&&J(r,[[a[0].headsStartAt,a[0].tailsEndAt]]).trim()===""&&(c=!0);let T=p(a,!0,c);return ee(T)||G(T)?T:s!=null&&s.current()?J(r,s.current()):r}function Yn(e,r){if(!arguments.length)throw new Error("json-variables/jVar(): [THROW_ID_01] Alas! Inputs are missing!");if(!E(e))throw new TypeError(`json-variables/jVar(): [THROW_ID_02] Alas! The input must be a plain object! Currently it's: ${Array.isArray(e)?"array":typeof e}`);if(r&&!E(r))throw new TypeError(`json-variables/jVar(): [THROW_ID_03] Alas! An Optional Options Object must be a plain object! Currently it's: ${Array.isArray(r)?"array":typeof r}`);let t=v(v({},Gr),r);t.dontWrapVars?Array.isArray(t.dontWrapVars)||(t.dontWrapVars=S(t.dontWrapVars)):t.dontWrapVars=[];let i,l;if(t.dontWrapVars.length&&!t.dontWrapVars.every((o,s)=>$(o)?!0:(i=o,l=s,!1)))throw new Error(`json-variables/jVar(): [THROW_ID_05] Alas! All variable names set in resolvedOpts.dontWrapVars should be of a string type. Computer detected a value "${i}" at index ${l}, which is not string but ${Array.isArray(i)?"array":typeof i}!`);if(t.heads==="")throw new Error("json-variables/jVar(): [THROW_ID_06] Alas! resolvedOpts.heads are empty!");if(t.tails==="")throw new Error("json-variables/jVar(): [THROW_ID_07] Alas! resolvedOpts.tails are empty!");if(t.lookForDataContainers&&t.dataContainerIdentifierTails==="")throw new Error("json-variables/jVar(): [THROW_ID_08] Alas! resolvedOpts.dataContainerIdentifierTails is empty!");if(t.heads===t.tails)throw new Error("json-variables/jVar(): [THROW_ID_09] Alas! resolvedOpts.heads and resolvedOpts.tails can't be equal!");if(t.heads===t.headsNoWrap)throw new Error("json-variables/jVar(): [THROW_ID_10] Alas! resolvedOpts.heads and resolvedOpts.headsNoWrap can't be equal!");if(t.tails===t.tailsNoWrap)throw new Error("json-variables/jVar(): [THROW_ID_11] Alas! resolvedOpts.tails and resolvedOpts.tailsNoWrap can't be equal!");if(t.headsNoWrap==="")throw new Error("json-variables/jVar(): [THROW_ID_12] Alas! resolvedOpts.headsNoWrap is an empty string!");if(t.tailsNoWrap==="")throw new Error("json-variables/jVar(): [THROW_ID_13] Alas! resolvedOpts.tailsNoWrap is an empty string!");if(t.headsNoWrap===t.tailsNoWrap)throw new Error("json-variables/jVar(): [THROW_ID_14] Alas! resolvedOpts.headsNoWrap and resolvedOpts.tailsNoWrap can't be equal!");let n;return ce(e,(o,s,p)=>{if(W(s)&&Be(o,t))throw new Error(`json-variables/jVar(): [THROW_ID_15] Alas! Object keys can't contain variables!
Please check the following key: ${o}`);if(s!==void 0?n=s:n=o,n==="")return n;if(t.heads.length&&_(n)===_(t.heads)||t.tails.length&&_(n)===_(t.tails)||t.headsNoWrap.length&&_(n)===_(t.headsNoWrap)||t.tailsNoWrap.length&&_(n)===_(t.tailsNoWrap)){if(!t.noSingleMarkers)return n;throw new Error(`json-variables/jVar(): [THROW_ID_16] Alas! While processing the input, we stumbled upon ${_(n)} which is equal to ${_(n)===_(t.heads)?"heads":""}${_(n)===_(t.tails)?"tails":""}${$(t.headsNoWrap)&&_(n)===_(t.headsNoWrap)?"headsNoWrap":""}${$(t.tailsNoWrap)&&_(n)===_(t.tailsNoWrap)?"tailsNoWrap":""}. If you wouldn't have set resolvedOpts.noSingleMarkers to "true" this error would not happen and computer would have left the current element (${_(n)}) alone`)}return $(n)&&Be(n,t)?zr(e,n,p.path,t):n})}return at(Xn);})();
/**
 * @name arrayiffy-if-string
 * @fileoverview Put non-empty strings into arrays, turn empty-ones into empty arrays. Bypass everything else.
 * @version 5.0.5
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/arrayiffy-if-string/}
 */
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.4.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name string-match-left-right
 * @fileoverview Match substrings on the left or right of a given index, ignoring whitespace
 * @version 9.0.11
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-match-left-right/}
 */
/**
 * @name string-collapse-leading-whitespace
 * @fileoverview Collapse the leading and trailing whitespace of a string
 * @version 7.0.5
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-collapse-leading-whitespace/}
 */
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 6.0.7
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */
/**
 * @name ranges-push
 * @fileoverview Gather string index ranges
 * @version 7.0.8
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-push/}
 */
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 9.0.8
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */
/**
 * @name ranges-apply
 * @fileoverview Take an array of string index ranges, delete/replace the string according to them
 * @version 7.0.8
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-apply/}
 */
/**
 * @name string-trim-spaces-only
 * @fileoverview Like String.trim() but you can choose granularly what to trim
 * @version 5.0.7
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-trim-spaces-only/}
 */
/**
 * @name string-remove-duplicate-heads-tails
 * @fileoverview Detect and (recursively) remove head and tail wrappings around the input string
 * @version 7.0.11
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-remove-duplicate-heads-tails/}
 */
/**
 * @name string-find-heads-tails
 * @fileoverview Finds where are arbitrary templating marker heads and tails located
 * @version 6.0.11
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-find-heads-tails/}
 */
/**
 * @name ast-monkey-util
 * @fileoverview Utility library of AST helper functions
 * @version 3.0.5
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ast-monkey-util/}
 */
/**
 * @name ast-monkey-traverse
 * @fileoverview Utility library to traverse AST
 * @version 4.0.9
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ast-monkey-traverse/}
 */
/**
 * @name ast-get-values-by-key
 * @fileoverview Extract values and paths from AST by keys OR set them by keys
 * @version 5.0.11
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ast-get-values-by-key/}
 */
